//******************************************************************************
//* Form utilities
//******************************************************************************

   /* input item */
   function item(n,e,v) {
   
     this.name = n;
     this.en = e;
     this.vis = v;     
   }
   
  function hasClass(who,cls) {
  
	return who.className.match(new RegExp('(\\s|^)'+cls+'(\\s|$)'));
  }
  
  function addClass(who,cls) {
  
	if (!hasClass(who,cls)) who.className += " "+cls;
  }
  
  function removeClass(who,cls) {
  
	if (hasClass(who,cls)) {
		var reg = new RegExp('(\\s|^)'+cls+'(\\s|$)');
		who.className=who.className.replace(reg,' ');
	}
  }
    
  function endsWith(str, e)
  {
    var last = str.lastIndexOf(e);
    
    return (last != -1) && (last + e.length == str.length);
  }
  
 
  function startsWith( str, s )
  {
    return str.indexOf(s) == 0;
  }
  
  
  function xleafeval( a, v ) {
  
    if ( this.a == a ) {
    
       return this.v == v; 
    }
  
    return null; 
  }
  
  function xleaf( a, v ) {
  
    this.a = a;
    this.v = v;
    this.evaluate = xleafeval;
  }
  
  function xoreval(a,v) {
  
    var ret = null;
  
    if ( this.children != null ) {
    
       for ( var i=0; i < this.children.length; i++ ) {
       
          var b = this.children[i].evaluate(a,v);
          
          if ( b == null ) {
          
            continue;
          }
          
          if ( b == true ) {
          
            return b;
          }
       
          ret = false;
       }
    }
    
    return ret;
  }
  
  function xornode( children ) {
  
    this.children = children;
    this.evaluate = xoreval;
  }
  
   function slice( str ) {
   
       var i = str.lastIndexOf("*)");
       
       if ( i == -1 ) {
       
          i = str.lastIndexOf(")");
       }
       
       if ( i != 0 ) {
       
          return str.slice(0, i);
       }
       
       return str;
   }
   
   
   /* field object */
   function field(name,en,vis) {
   
     this.name = name;
     this.en = en;
     this.vis = vis;     
   }
   
   /* filter object */
   function filter(op,list) {
   
     this.op = op;
     this.list = list;    
   }
   
   /* filter evaluate method */
   filter.prototype.evaluate = function() {
   
      if ( this.list == null || this.list.length == 0 ) {
      
         // ignore
         
      } else if ( this.op == 'or' ) {
         
          for ( var i=0; i < this.list.length; i++ ){
             
             if ( this.list[i].evaluate() == true ) {
                
                return true;
             }
          }
             
          return false;
         
      } else if ( this.op == 'and' ) {
                     
          for ( var i=0; i < this.list.length; i++ ){
             
            if ( this.list[i].evaluate() == false ) {
                
                return false;
            }
         }
             
         return true;         
     }
     
     return null;
   };
   
   /* simple item object */
   function simple(op,attr,val) {
   
     this.op = op;
     this.attr = attr;
     this.val = val;
   } 
   
   /* filter evaluate method */
   simple.prototype.evaluate = function() {
    
      var a = null;
     
      try {
     
          a = document.getElementById(this.attr).value;
          
          if ( this.op == 'eq' ) {  // = ?
          
             if ( this.val == a ) {
             
                return true;
             }   
          } else if ( this.op == 'ge' ) {  // >= ?
          
             if ( a >= this.val ) {
             
                return true;
             } 
          } else if ( this.op == 'le' ) {  // <= ?
          
             if ( a <= this.val ) {
             
                return true;
             }                  
          } else if ( this.op == 'present' ) {  // =* ?
          
             if ( a != null ) {
             
                return true;
             } 
          } else if ( this.op == 'like' ) {  // like ?
          
             // value contains a regular expression.
             // finish this thought!
          }
                                 
          return false;
 
      } catch(E){ 

      }
      
      return null;
   };
   
   function check( str, s, p ) {
   
     if ( "true" == str ) {
     
        return true;
     }
     
     if ( "false" == str ) {
     
        return false;
     } 
     
     if ( !startsWith( str, s) ) {
       
         return null;
     } 
     
     var en = slice(str);
       
     return startsWith( p, en);  
   }
   
     /* Handle changes from selected objects */
   function handleChange( items, who ) {
           
     if( who == null ) {
     
       return;
     }
     
     var p = "(" + who.name + "=" + who.value;
     var s = "(" + who.name + "=";
    
     for ( var i=0, len=items.length; i<len; ++i ){
      
       var item = items[i];
       
       if ( item == null ) {
       
         continue;
       } 
              
       var a = check(item.vis, s, p);
    
       if ( a == null ) {
       
         // ignore
         
       } else if ( a ) {
       
          showId(items[i].name);
          
       } else {
       
          hideId(items[i].name);
       }   
       
       var b = check(item.en, s, p);
       
       if ( b == null ) {
       
         // ignore
         
       } else if ( b ) {
       
         enableId(items[i].name);
         
       } else {
       
         disableId(items[i].name);
       }
     }
   }
   
   /* Handle changes from selected objects */
   
   function handleChange2( fields, who ) {
   
     // For now, ignore who changed.
           
     if( who == null ) {
     
       return;
     }
                  
     for ( var i=0; i < fields.length; i++ ){
          
       if ( fields[i] == null ) {
       
         continue;
       } 
       
       if ( fields[i].vis ) {
                          
         var a = fields[i].vis.evaluate();
    
         if ( a == null ) {
       
          // ignore
         
         } else if ( a ) {
       
           showId(fields[i].name);
          
         } else {
       
           hideId(fields[i].name);
         }   
       }
          
       if ( fields[i].en ) {
                                  
         var b = fields[i].en.evaluate();
                      
         if ( b == null ) {
       
            // ignore
       
         } else if ( b ) {
       
           enableId(fields[i].name);
         
         } else {
       
           disableId(fields[i].name);
         }  
       }
     }
   } 
   
  
  /* select by id*/
  function selectId(items,id) {
  
     try {
     
        handleChange( items, document.getElementById(id));
 
     } catch(E){ 

     }
  }
  
  /* select by id*/
  function selectId2(fields,id) {
  
     try {
     
        handleChange2( fields, document.getElementById(id));
 
     } catch(E){ 

     }
  }
  
  /* enable by id */
  function enableId(id) {
  
     try {
     
       setDisable( document.getElementById(id), false);
        
     } catch(E){ 
     }
  }
  
  /* disable by id */
  function disableId(id) {
  
     try {
     
        setDisable( document.getElementById(id), true);
 
     } catch(E){ 
     }
  }
  
  /* disable / enable the specified node */
  function setDisable( who, b ) {
 
        who.disabled = b;
             
        if (who.childNodes && who.childNodes.length > 0) {
        
          for (var x = 0; x < who.childNodes.length; x++) {
          
             setDisable(who.childNodes[x], b);
          }
        }
  }
  
  /* hide by id (div expected) */
  function hideId(id) {
  
     try {
     
        var who = document.getElementById(id);
        who.style.display = 'none';
        
     } catch(E){ 
     }
  }
  
   /* show by id (div expected) */
   function showId(id) {
   
     try {
     
         var who = document.getElementById(id);
         who.style.display = 'block';
         
     }  catch(E){ 
     }
  }



/* Handle focus */
function handleFocus( who ) {
  
}   
   
/* Handle blur */
function handleBlur( who ) {
   

}

/* Set focus */
function setFocus( id ) {

     window.onload = chain(window.onload, function() {
        try {
    
        var who = document.getElementById(id);
        who.focus();
        handleFocus( who);
     
       } catch (E) {
       }
    });
}

 
/* Clicked */
function clicked( action, msg, target ) {
  
     if ( msg == '' || confirm(msg) ) {
     
       if ( target == 'config' ) {
       
           openConfig( action );
           
       } else if ( target == 'help' ) {
       
           openHelp( action );
       
       } else {
     
           window.location = action;   
       }
     }    
}
  
/* Submit the form with optional action */
function submitForm( formn, action, msg, target ) {
  
    try {
    
       var form = document.getElementById(formn);
       
       if ( msg == '' || confirm(msg) ) {
       
         if ( action != '' ) {
 
            form.action = action;
         }
         
         if ( target != '' ) {
         
            form.target = target;
         }
         
         window.onbeforeunload = null;
          
         form.submit();    
       }   
    }  catch(E) { } 
}