/*
 * IBM Technical Support Appliance Version 2 Release 0 Modification 0
 *
 * (C) Copyright IBM Corp. 2017
 */

//-----------------------------------------------------------------------------

define(
  [ 'jquery' ],
  
  function( $ )
  {
    //-------------------------------------------------------------------------
    
    /**
     * This class is not supposed to be instantiated.
     */
    tsa.TypeVerificator = function( parameters )
    {
      /*
       * Nothing to do: this class is not supposed to be instantiated.
       */
    };
    
    //-------------------------------------------------------------------------
    
    /*
     * Warning: some browsers mark some native functions as objects (as IE) and
     * some other browsers mark some native objects as functions (Safari marks
     * HTML collection instances -as tbodies and childNodes- as functions).
     */
    
    tsa.TypeVerificator.typeIsUndefined = function( aType ) { return ( aType === ( typeof {}[ '_' ] ) ); };
    tsa.TypeVerificator.typeIsNumber    = function( aType ) { return ( aType === ( typeof 0         ) ); };
    tsa.TypeVerificator.typeIsString    = function( aType ) { return ( aType === ( typeof ''        ) ); };
    tsa.TypeVerificator.typeIsBoolean   = function( aType ) { return ( aType === ( typeof true      ) ); };
    tsa.TypeVerificator.typeIsObject    = function( aType ) { return ( aType === ( typeof null      ) ); };
    tsa.TypeVerificator.typeIsFunction  = function( aType ) { return ( aType === ( typeof function() { return 0; } ) ); };
    
    /** Is A instance of B?
     *  @param {Object}   a Object A.
     *  @param {Function} b Object B.
     *  @return {boolean} */
    
    tsa.TypeVerificator.isInstanceOf = function( a, b )
    {
      /** @type {boolean} */ var result = false;
      
      if( tsa.TypeVerificator.typeIsObject   ( typeof a ) && ( a !== null ) &&
          tsa.TypeVerificator.typeIsFunction ( typeof b ) && ( b !== null ) )
      {
        if( tsa.TypeVerificator.typeIsFunction( typeof a.isInstanceOf ) && ( a.isInstanceOf !== null ) )
        {
          try { result = a.isInstanceOf( b ); } catch( error ) { try { result = ( a instanceof b ); } catch( error2 ) { } };
        }
        else
        {
          try { result = ( a instanceof b ); } catch( error ) { }
        }
      }
      
      return result;
    };
    
    //-------------------------------------------------------------------------
    
    return tsa.TypeVerificator;
  }
);

//-----------------------------------------------------------------------------