/*
 * IBM Technical Support Appliance Version 2 Release 0 Modification 0
 *
 * (C) Copyright IBM Corp. 2017
 */

//-----------------------------------------------------------------------------

define(
  [ 'jquery'
  , 'tsa/TypeVerificator'
  , 'tsa/cmd/handlers/AbstractHandler'
  , 'tsa/widgets/ContentArea'
  , 'tsa/cmd/Command'
  , 'tsa/widgets/FormPanel'
  , 'tsa/widgets/TablePanel'
  , 'tsa/widgets/ButtonFactory'
  ],
  
  function( $
          , TV
          , AbstractHandler
          , ContentArea
          , Command
          , FormPanel
          , TablePanel
          , ButtonFactory
          )
  {
    //-------------------------------------------------------------------------
    
    var logger = tsa.getLogger( 'EntityidsettingsHandler' );
    
    //-------------------------------------------------------------------------
    
    /** @constructor
     *  @extends tsa.cmd.AbstractHandler
     *  Parameters added by this class (in addition to super-class' parameters):
     *    none.
     *    
     *  @param {Object} parameters The parameters. */
    
    tsa.cmd.handlers.EntityidsettingsHandler =  function( parameters )
    {
      if( !TV.typeIsObject( typeof parameters ) || ( parameters === null ) ) parameters = /** @type {?} */ ( {} );
      
      // Calling the constructor of the super-class...
      AbstractHandler.prototype.constructor.call( this, parameters );
    };
    
    //-------------------------------------------------------------------------
    
    // Inheriting:
    tsa.cmd.handlers.EntityidsettingsHandler.prototype = new AbstractHandler( {} );
    /** @type {?} */ ( tsa.cmd.handlers.EntityidsettingsHandler.prototype ).constructor = tsa.cmd.handlers.EntityidsettingsHandler;
    
    //-------------------------------------------------------------------------
    /**
     * Show main screen.
     */
    tsa.cmd.handlers.EntityidsettingsHandler.prototype._index = function()
    {
      /** @type {Object}                  */ var i18n         = tsa.i18n;
      /** @type {tsa.widgets.ContentArea} */ var contentArea  = null;
      /** @type {Element}				  */ var genDiv 	  = null;
      /** @type {Element}  				  */ var delDiv 	  = null;
      /** @type {tsa.cmd.Command}         */ var getAppIdCmd  = new Command( { action  : 'entityidsettings/getAppId' } );
      
      
      // Initialize the content area (its title and its help document)...
      contentArea = new ContentArea ( { title   : i18n.labelEntityIDHeading
                                      , helpDoc : 'sshelp_entityidmanagement_panel.html' } );
      
      contentArea.appendMessage( { text : i18n.labelEntityIDCaption } );
      
      //Current Id
      var appidDiv = document.createElement( 'div' );
      $( appidDiv ).attr('id' , 'appid');
      $( appidDiv ).addClass('ibm-container');
      $( appidDiv ).css({ 'display' : 'block'});
      
      var appidHeader = document.createElement( 'h2' ); 
      $( appidHeader ).text( i18n.labelEntityIDlabelHeading );
      $( appidDiv ).append( appidHeader );
      
      var appidDiv2 = document.createElement( 'div' );
      $( appidDiv2 ).addClass('ibm-container-body');
      
      var appidParag = document.createElement( 'p' );
      $( appidParag ).addClass('ibm-container-body');
      
      $( appidDiv2 ).append( appidParag );
      $( appidDiv ).append( appidDiv2 );
      contentArea.append( appidDiv );
     
      
      //Delete Id
      delDiv = document.createElement( 'div' );
      $( delDiv ).attr('id' , 'appid');
      $( delDiv ).addClass('ibm-container');
      $( delDiv ).css({ 'display' : 'block'});
      
      var delHeader = document.createElement( 'h2' ); 
      $( delHeader ).text( i18n.labelEntityIDDeleteHeading );
      $( delDiv ).append( delHeader );
      
      var delDiv2 = document.createElement( 'div' );
      $( delDiv2 ).addClass('ibm-container-body');
      
      var delParag = document.createElement( 'p' );
      $( delParag ).addClass('ibm-container-body');
      
      var delCap = document.createElement( 'div' );
      $( delCap ).css({ 'margin-bottom' : '5px' });
      $( delCap ).text( i18n.labelEntityIDDeleteCaption );
      $( delParag ).append( delCap );

      var delDiv3 = document.createElement( 'div' );
 	  var delHr = document.createElement( 'hr' );
 	  $( delDiv3 ).addClass('ibm-rule');
 	  $( delDiv3 ).append( delHr );
 	  $( delParag ).append( delDiv3 );
      
 	  var delDiv4 = document.createElement( 'div' );
      var delButton = ButtonFactory.buildButton(
      		  { type : 'arrow' 
    	  	  , label : i18n.buttonlabelDeleteEntityID 
    	  	  , onclick : function( event ){ 
    	  		  var delCmd = new Command({ action : 'entityidsettings/ajaxDeleteId', blockUI : false });
    	  		  if ( confirm(i18n.labelDeleteidConfirm)) {
    	  			  delCmd.execute();
    	  		  }
    	  		  
    	  		 $( delCmd ).on( 'executionSucceeded', function( event ){
    	  			 $( appidParag ).text( event.response.payload.appId );
    	  		  	 $( delDiv ).hide();
    	  		  	 $( genDiv ).show();
    	  		 });
    	  	  }
      	});
      $( delButton ).css({ 'margin-top' : '5px'});

      $( delDiv4 ).append( delButton );
      $( delParag ).append( delDiv4 );
      $( delDiv ).append( delParag );
      $( delDiv ).hide();
 	  contentArea.append( delDiv );
     
 	  
      //Generate Id
      genDiv = document.createElement( 'div' );
      $( genDiv ).attr('id' , 'appid');
      $( genDiv ).addClass('ibm-container');
      $( genDiv ).css({ 'display' : 'block'});
      
      var genHeader = document.createElement( 'h2' ); 
      $( genHeader ).text( i18n.labelEntityIDGenerateHeading );
      $( genDiv ).append( genHeader );
      
      var genDiv2 = document.createElement( 'div' );
      $( genDiv2 ).addClass('ibm-container-body');
      
      var genParag = document.createElement( 'p' );
      $( genParag ).addClass('ibm-container-body');
      
      var genCap = document.createElement( 'div' );
      $( genCap ).css({ 'margin-bottom' : '5px' });
      $( genCap ).text( i18n.labelEntityIDGenerateCaption );
      $( genParag ).append( genCap );
      
      var genDiv3 = document.createElement( 'div' );
 	  var genHr = document.createElement( 'hr' );
 	  $( genDiv3 ).addClass('ibm-rule');
 	  $( genDiv3 ).append( genHr );
 	  $( genParag ).append( genDiv3 );
      
      var genDiv4 = document.createElement( 'div' );
 	  var genButton = ButtonFactory.buildButton(
     	  { type : 'arrow' 
   	  	  , label : i18n.buttonlabelGenerateEntityID 
   	  	  , onclick : function( event ){ 
   	  		  var genCmd = new Command({ action : 'entityidsettings/ajaxGenerateId'});
   	  		  if ( confirm(i18n.labelGenerateidConfirm)) {
   	  			  genCmd.execute();
   	  		  }
   	  		  
   	  		 $( genCmd ).on( 'executionSucceeded', function( event ){
   	  			 $( appidParag ).text( event.response.payload.appId );
   	  			 $( genDiv ).hide();
   	  		  	 $( delDiv ).show();
   	  		 });
   	  	  }
      });
      $( genButton ).css({ 'margin-top' : '5px'});

      $( genDiv4 ).append( genButton );
      $( genParag ).append( genDiv4 );
      $( genDiv ).append( genParag );
      $( genDiv ).hide();
      contentArea.append( genDiv );
      
      
      //get app id
      $( getAppIdCmd ).on( 'executionSucceeded', function( event ){
    	 var isSet = event.response.payload.isSet;
    	 $( appidParag ).text( event.response.payload.appId );
    	 
    	 if(isSet) {
    		 $( delDiv ).show();
       	 }else{
       		 $( genDiv ).show();
         }
     	
      });
      
    
      //Get app id
      getAppIdCmd.execute();
      
      this.show( contentArea.getDomNode() );
    };
    
    //-------------------------------------------------------------------------
    
    return tsa.cmd.handlers.EntityidsettingsHandler;
  }
);