/*
 * IBM Technical Support Appliance Version 2 Release 0 Modification 0
 *
 * (C) Copyright IBM Corp. 2017
 */

//-----------------------------------------------------------------------------

define(
  [ 'jquery'
  , 'tsa/TypeVerificator'
  , 'tsa/cmd/handlers/AbstractHandler'
  , 'tsa/widgets/ContentArea'
  , 'tsa/widgets/TablePanel'
  , 'tsa/cmd/Command'
  , 'tsa/cmd/ShowCommand'
  , 'tsa/widgets/ButtonFactory'
  ],
  
  function( $
          , TV
          , AbstractHandler
          , ContentArea 
          , TablePanel
          , Command 
          , ShowCommand
          , ButtonFactory )
  {
    //-------------------------------------------------------------------------
    
    var logger = tsa.getLogger( 'InventorysummaryHandler' );
    
    //-------------------------------------------------------------------------
    
   
    
    /** @constructor
     *  @extends tsa.cmd.AbstractHandler
     *  Parameters added by this class (in addition to super-class' parameters):
     *    none.
     *    
     *  @param {Object} parameters The parameters. */
    
    tsa.cmd.handlers.InventorysummaryHandler =  function( parameters )
    {
      if( !TV.typeIsObject( typeof parameters ) || ( parameters === null ) ) parameters = /** @type {?} */ ( {} );
      
      // Calling the constructor of the super-class...
      AbstractHandler.prototype.constructor.call( this, parameters );
    };
    
    //-------------------------------------------------------------------------
    
    // Inheriting:
    tsa.cmd.handlers.InventorysummaryHandler.prototype = new AbstractHandler( {} );
    /** @type {?} */ ( tsa.cmd.handlers.InventorysummaryHandler.prototype ).constructor = tsa.cmd.handlers.InventorysummaryHandler;
    //-------------------------------------------------------------------------
    
    //sidebar to show info of elements
    tsa.cmd.handlers.InventorysummaryHandler.prototype.infoParagraph   = null;
    /**
     * Show main screen.
     */
    tsa.cmd.handlers.InventorysummaryHandler.prototype._index = function()
    {
      /** @type {Object}                  */    var i18n                     = tsa.i18n;
      /** @type {tsa.widgets.ContentArea} */    var contentArea              = new ContentArea ( { title : i18n.labelInventorySummaryHeading
                                                                                               , helpDoc       : 'sshelp_inventory_summary_panel.html'} );
      /** @type {tsa.widgets.ContentArea} */     var tablePanel               = new TablePanel( { title: i18n.labelInventorySummaryHeading 
                                                                                              , columns: [ { id : "id"  , width : '40%'  }
                                                                                                         , { id : "type", width : '60%' }] 
                                                                                               , summary : "Summary InventorySummary"} );
      /** @type {tsa.cmd.Command} */             var getInventorySummary      = null;
      
      /** @type {tsa.cmd.Command} */             var cmdInfo                  = null;
      /** @type {tsa.widgets.ButtonFactory} */   var buttonContainer         = ButtonFactory.buildButtonContainer();
      
      contentArea.appendMessage( { text : i18n.labelInventorySummaryCaption } );
      
      getInventorySummary = new Command({ action:'inventorysummary/getInventory'
                                          ,clearSystemMessages:false            });
      
      getInventorySummary.execute();
      
      $(getInventorySummary).on('executionSucceeded', function(event){
        
        /**@type {Object[]} */ var inventoryGroups  = event.response.payload.inventoryGroups;
        /** @type {string} */  var imgPath          = "/appliance/resources/images/inventory/";
       if( !TV.typeIsUndefined( typeof inventoryGroups ) ){
         
            if(inventoryGroups.length>0){
              
            $.each( inventoryGroups, function( igsIndex, group )
                {
                  
                  /**@type {element} */  var size             = group.types.length;
                    if(size>0){
                      
                      /** @type {tsa.cmd.ShowCommand} */ var showCmd  = new ShowCommand( { action : 'inventorysummary/type' } );
                      /** @type {Element} */             var imgGroup = document.createElement("img");
                      /** @type {Element} */             var row      = document.createElement("tr");
                      /** @type {Element} */             var cell1    = row.insertCell(0);
                      /** @type {Element} */             var cell2    = row.insertCell(1);
                      $(imgGroup).attr('src', imgPath + group.icon);
                      $(imgGroup).attr('alt', '');
                      $(cell1).attr('rowSpan', group.types.length);
                      $(cell1).append(imgGroup);
                      $(cell1).append(tsa.NBSP);
                      $(cell1).append(group.label );
                      $( cell1 ).css( { 'border-right'           : '1px solid #cdd0d4'     } );
                      /** @type {Element} */ var imgType = document.createElement("img");
                      /** @type {object}  */ var rowType = group.types[0];
                      /** @type {Element} */ var a       = document.createElement("a");
                      /** @type {Element} */ var strong  = document.createElement("strong");
                      $(imgType).attr('src',imgPath+rowType.icon);
                      $(imgType).attr('alt','');
                      $(a).attr('alt', rowType.label);
                      $(a).attr('href', '#');
                      
                      $(strong).append( rowType.label );
                      $(a     ).append( imgType      );
                      $(a     ).append( strong       );
                      $(cell2 ).append( a            );
                      
                      $( cell2 ).on( 'click', function( event )
                          {
                            showCmd.setParameter("name",rowType.name);
                            //send parameter without number
                            /** @type {string} */ var subtitle=rowType.label.substring(0, rowType.label.indexOf('('));
                            showCmd.setParameter("subTitle",subtitle)
                            showCmd.execute();
                          } );
                      $(tablePanel.tableBody).append(row);
                      
                      $.each( group.types, function( igIndex, type )
                      {
                        if(igIndex>0){
                          a           = document.createElement("a"      );
                          strong      = document.createElement("strong" );
                          imgType     = document.createElement("img"    );
                          row         = document.createElement("tr"     );
                          cell1       = row.insertCell(0);
                          $(imgType).attr('alt','');
                          $(imgType).attr('src',imgPath+type.icon);
                          $(a      ).attr( 'href', "#");
                          $(a      ).attr( 'alt', type.label );
                          $(a      ).append(strong);
                          $(strong ).append(type.label);
                          $(a ).append(imgType,strong);
                          $(cell1  ).append(a);
                          
                          $( cell1 ).on( 'click', function( event )
                              {
                                showCmd.setParameter("name",type.name);
                                /** @type {string} */ var subtitle=type.label.substring(0, type.label.indexOf('('));
                                showCmd.setParameter("subTitle",subtitle)
                                showCmd.execute();
                              } );
                          $(tablePanel.tableBody).append(row);
                        }
                      });
                      //create the table normal
                    }else{
                      /** @type {Element} */ var imgGroup = document.createElement("img");
                      /** @type {Element} */ var   row = document.createElement("tr");
                      /** @type {Element} */ var cell1 = row.insertCell(0);
                      /** @type {Element} */ var cell2 = row.insertCell(1);
                      $(imgGroup).attr('src', imgPath+group.icon);
                      $(imgGroup).attr('alt', '');
                      $(cell1).append(imgGroup);
                      $(cell1).append(tsa.NBSP);
                      $(cell1).append(group.label);
                      $(cell2).append( i18n.labelInventorySummaryTypeNoObjects);
                      $(tablePanel.tableBody).append(row);
                    }
                    } );
                tablePanel.appendRow( [ i18n.labelInventorySummaryLastGenerated + event.response.payload.collectedOnTS ,""] );
            
            }else{
              tablePanel.appendRow([i18n.labelInventorySummaryNoReport,""]);
            }
          }else{
          
          tablePanel.appendRow([i18n.labelInventorySummaryNoReport,""]);
        }
       });
      $( buttonContainer ).append(
          ButtonFactory.buildButton(
            { type    : 'download'
            , grayout : false
            , label   : i18n.buttonInventorySummaryDownloadReport
            , onclick : function( event )
              {    
              window.location = '/appliance/inventorysummary/run/inventorySummary.txt';
              }
            }
          )
        );
      contentArea.append(tablePanel.getDomNode())
      contentArea.append( buttonContainer );
      this.show( contentArea.getDomNode() );
    };
    //-------------------------------------------------------------------------
    tsa.cmd.handlers.InventorysummaryHandler.prototype._type = function()
    {
      /** @type {string}                  */    var requestName              = this.getParameter ( 'name' );
      /** @type {string}                  */    var subTitle                 = this.getParameter ( 'subTitle' );
      /** @type {string}                  */    var actionURL                = 'inventorysummary/getType/' + requestName.toLowerCase();
      /** @type {Object}                  */    var i18n                     = tsa.i18n;
      /** @type {tsa.widgets.ContentArea} */    var contentArea                 = new ContentArea   ( { title : i18n.labelInventorySummaryTypeHeading 
                                                                                                     , helpDoc       : 'sshelp_inventory_detail_panel.html'} );
      //retrieving data from server
      /** @type {tsa.widgets.TablePanel} */     var tablePanel              = new TablePanel( { title        : i18n.labelInventorySummaryTypeHeading
                                                                                , summary      : i18n.labelInventorySummaryTypeObjectsHeading
                                                                                , ajaxAction   : actionURL
                                                                                , entryHandler : $.proxy(this.infoEntryHandler,this)
                                                                                , pageSize     : 10
                                                                                , columns      : [ { id : "name"            , label : i18n.labelInventorySummaryTypeName         , width : '60%' , initSort : true }
                                                                                                 , { id : "lastModified"    , label : i18n.labelInventorySummaryTypeLastModified , width : '40%' } ] } );
      contentArea.appendMessage({ text : subTitle});
      
      contentArea.append(tablePanel.getDomNode());
      this.infoParagraph = document.createElement("div");
      /** @type {element}                  */    var paragraph              = document.createElement("p");
      $(paragraph).text(i18n.labelInventorySummaryTypeNoObjectSelected);
      $(this.infoParagraph).append(paragraph);
      contentArea.appendSidebarPanel( { title: i18n.labelInventorySummaryTypeObjectInfo, body: this.infoParagraph } );
      
      this.show( contentArea.getDomNode() );
     };
     //-------------------------------------------------------------------------
     tsa.cmd.handlers.InventorysummaryHandler.prototype.infoEntryHandler = function( entry )
     {
         
        /** @type {Array.<(string|Element)>} */ var result             = null;
        /** @type {Element}                  */ var dName              = document.createElement("div");
        /** @type {Element}                  */ var dModified          = document.createElement("div");
        
        //event to handle click
        /** @type {function()}               */ 
        var clickEventHandler  = $.proxy(function(event){
          /** @type {string}          */ var actionURL    = 'inventorysummary/getInfo/' + entry.pid;
          /** @type {tsa.cmd.Command} */ var cmdInfo      = new Command( { action : actionURL
                                                                         , clearSystemMessages:false} );
          
            cmdInfo.execute();
            
            $(cmdInfo).on('executionSucceeded', $.proxy(function(event){
              
              $( this.infoParagraph ).empty();
              /** @type {Object}                  */  var i18n             = tsa.i18n; 
              /** @type {Object}                   */ var object           = event.response.payload.object;
              /** @type {Element}                  */ var pIP              = document.createElement("p");
              /** @type {Element}                  */ var pManufacturer    = document.createElement("p");
              /** @type {Element}                  */ var pModel           = document.createElement("p");
              /** @type {Element}                  */ var pSNumber         = document.createElement("p");
              /** @type {Element}                  */ var sIP              = document.createElement("strong");
              /** @type {Element}                  */ var sManufacturer    = document.createElement("strong");
              /** @type {Element}                  */ var sModel           = document.createElement("strong");
              /** @type {Element}                  */ var sSNumber         = document.createElement("strong");
              
              $(sIP          ).text(i18n.labelInventorySummaryDetailsContextIp    + ':');
              $(sManufacturer).text(i18n.labelInventorySummaryDetailsManufacturer + ':');
              $(sModel       ).text(i18n.labelInventorySummaryDetailsModel        + ':');
              $(sSNumber     ).text(i18n.labelInventorySummaryDetailsSerialNumber + ':');
              
              $(pIP          ).append(sIP           ,document.createElement( 'br' ),document.createTextNode( object.contextIp    ));
              $(pManufacturer).append(sManufacturer ,document.createElement( 'br' ),document.createTextNode( object.manufacturer ));
              $(pModel       ).append(sModel        ,document.createElement( 'br' ),document.createTextNode( object.model        ));
              $(pSNumber     ).append(sSNumber      ,document.createElement( 'br' ),document.createTextNode( object.serialNumber ));
              
              $(this.infoParagraph).append( pIP          );
              $(this.infoParagraph).append( pManufacturer);
              $(this.infoParagraph).append( pModel       );
              $(this.infoParagraph).append( pSNumber     );
                
              }, this));
        },this);
        $( dName     ).on( 'click', clickEventHandler );
        $( dModified ).on( 'click', clickEventHandler );
        $( dName     ).append( entry.displayName    );
        $( dModified ).append( entry.lastModifiedTS );
        
        return [ dName , dModified ];
     };
    
    return tsa.cmd.handlers.InventorysummaryHandler;
  }
);