/*
 * IBM Technical Support Appliance Version 2 Release 6 Modification 0
 *
 * (C) Copyright IBM Corp. 2019
 */

define(
  [ 'jquery'
  , 'tsa/TypeVerificator'
  ],
  
  function( $
          , TV
          )
  {
    /**
     * This module is not a constructor, but a set of functions.
     */
    tsa.data.Countries = {};
    
    /**
     * The data, as an array, sorted by the country name in English.
     * @private
     * @type {Array.<Object>}
     */
    tsa.data.Countries._data =
    [   { id : 'AF' , name : { label : 'labelCountryAF' } }
      , { id : 'AX' , name : { label : 'labelCountryAX' } }
      , { id : 'AL' , name : { label : 'labelCountryAL' } }
      , { id : 'DZ' , name : { label : 'labelCountryDZ' } }
      , { id : 'AS' , name : { label : 'labelCountryAS' } }
      , { id : 'AD' , name : { label : 'labelCountryAD' } }
      , { id : 'AO' , name : { label : 'labelCountryAO' } }
      , { id : 'AI' , name : { label : 'labelCountryAI' } }
      , { id : 'AQ' , name : { label : 'labelCountryAQ' } }
      , { id : 'AG' , name : { label : 'labelCountryAG' } }
      , { id : 'AR' , name : { label : 'labelCountryAR' } }
      , { id : 'AM' , name : { label : 'labelCountryAM' } }
      , { id : 'AW' , name : { label : 'labelCountryAW' } }
      , { id : 'AU' , name : { label : 'labelCountryAU' } }
      , { id : 'AT' , name : { label : 'labelCountryAT' } }
      , { id : 'AZ' , name : { label : 'labelCountryAZ' } }
      , { id : 'BS' , name : { label : 'labelCountryBS' } }
      , { id : 'BH' , name : { label : 'labelCountryBH' } }
      , { id : 'BD' , name : { label : 'labelCountryBD' } }
      , { id : 'BB' , name : { label : 'labelCountryBB' } }
      , { id : 'BY' , name : { label : 'labelCountryBY' } }
      , { id : 'BE' , name : { label : 'labelCountryBE' } }
      , { id : 'BZ' , name : { label : 'labelCountryBZ' } }
      , { id : 'BJ' , name : { label : 'labelCountryBJ' } }
      , { id : 'BM' , name : { label : 'labelCountryBM' } }
      , { id : 'BT' , name : { label : 'labelCountryBT' } }
      , { id : 'BO' , name : { label : 'labelCountryBO' } }
      , { id : 'BA' , name : { label : 'labelCountryBA' } }
      , { id : 'BW' , name : { label : 'labelCountryBW' } }
      , { id : 'BV' , name : { label : 'labelCountryBV' } }
      , { id : 'BR' , name : { label : 'labelCountryBR' } }
      , { id : 'IO' , name : { label : 'labelCountryIO' } }
      , { id : 'BN' , name : { label : 'labelCountryBN' } }
      , { id : 'BG' , name : { label : 'labelCountryBG' } }
      , { id : 'BF' , name : { label : 'labelCountryBF' } }
      , { id : 'BI' , name : { label : 'labelCountryBI' } }
      , { id : 'KH' , name : { label : 'labelCountryKH' } }
      , { id : 'CM' , name : { label : 'labelCountryCM' } }
      , { id : 'CA' , name : { label : 'labelCountryCA' } }
      , { id : 'CV' , name : { label : 'labelCountryCV' } }
      , { id : 'KY' , name : { label : 'labelCountryKY' } }
      , { id : 'CF' , name : { label : 'labelCountryCF' } }
      , { id : 'TD' , name : { label : 'labelCountryTD' } }
      , { id : 'CL' , name : { label : 'labelCountryCL' } }
      , { id : 'CN' , name : { label : 'labelCountryCN' } }
      , { id : 'CX' , name : { label : 'labelCountryCX' } }
      , { id : 'CC' , name : { label : 'labelCountryCC' } }
      , { id : 'CO' , name : { label : 'labelCountryCO' } }
      , { id : 'KM' , name : { label : 'labelCountryKM' } }
      , { id : 'CG' , name : { label : 'labelCountryCG' } }
      , { id : 'CD' , name : { label : 'labelCountryCD' } }
      , { id : 'CK' , name : { label : 'labelCountryCK' } }
      , { id : 'CR' , name : { label : 'labelCountryCR' } }
      , { id : 'CI' , name : { label : 'labelCountryCI' } }
      , { id : 'HR' , name : { label : 'labelCountryHR' } }
      , { id : 'CU' , name : { label : 'labelCountryCU' } }
      , { id : 'CY' , name : { label : 'labelCountryCY' } }
      , { id : 'CZ' , name : { label : 'labelCountryCZ' } }
      , { id : 'DK' , name : { label : 'labelCountryDK' } }
      , { id : 'DJ' , name : { label : 'labelCountryDJ' } }
      , { id : 'DM' , name : { label : 'labelCountryDM' } }
      , { id : 'DO' , name : { label : 'labelCountryDO' } }
      , { id : 'EC' , name : { label : 'labelCountryEC' } }
      , { id : 'EG' , name : { label : 'labelCountryEG' } }
      , { id : 'SV' , name : { label : 'labelCountrySV' } }
      , { id : 'GQ' , name : { label : 'labelCountryGQ' } }
      , { id : 'ER' , name : { label : 'labelCountryER' } }
      , { id : 'EE' , name : { label : 'labelCountryEE' } }
      , { id : 'ET' , name : { label : 'labelCountryET' } }
      , { id : 'FK' , name : { label : 'labelCountryFK' } }
      , { id : 'FO' , name : { label : 'labelCountryFO' } }
      , { id : 'FJ' , name : { label : 'labelCountryFJ' } }
      , { id : 'FI' , name : { label : 'labelCountryFI' } }
      , { id : 'FR' , name : { label : 'labelCountryFR' } }
      , { id : 'GF' , name : { label : 'labelCountryGF' } }
      , { id : 'PF' , name : { label : 'labelCountryPF' } }
      , { id : 'TF' , name : { label : 'labelCountryTF' } }
      , { id : 'GA' , name : { label : 'labelCountryGA' } }
      , { id : 'GM' , name : { label : 'labelCountryGM' } }
      , { id : 'GE' , name : { label : 'labelCountryGE' } }
      , { id : 'DE' , name : { label : 'labelCountryDE' } }
      , { id : 'GH' , name : { label : 'labelCountryGH' } }
      , { id : 'GI' , name : { label : 'labelCountryGI' } }
      , { id : 'GR' , name : { label : 'labelCountryGR' } }
      , { id : 'GL' , name : { label : 'labelCountryGL' } }
      , { id : 'GD' , name : { label : 'labelCountryGD' } }
      , { id : 'GP' , name : { label : 'labelCountryGP' } }
      , { id : 'GU' , name : { label : 'labelCountryGU' } }
      , { id : 'GT' , name : { label : 'labelCountryGT' } }
      , { id : 'GG' , name : { label : 'labelCountryGG' } }
      , { id : 'GN' , name : { label : 'labelCountryGN' } }
      , { id : 'GW' , name : { label : 'labelCountryGW' } }
      , { id : 'GY' , name : { label : 'labelCountryGY' } }
      , { id : 'HT' , name : { label : 'labelCountryHT' } }
      , { id : 'HM' , name : { label : 'labelCountryHM' } }
      , { id : 'VA' , name : { label : 'labelCountryVA' } }
      , { id : 'HN' , name : { label : 'labelCountryHN' } }
      , { id : 'HK' , name : { label : 'labelCountryHK' } }
      , { id : 'HU' , name : { label : 'labelCountryHU' } }
      , { id : 'IS' , name : { label : 'labelCountryIS' } }
      , { id : 'IN' , name : { label : 'labelCountryIN' } }
      , { id : 'ID' , name : { label : 'labelCountryID' } }
      , { id : 'IR' , name : { label : 'labelCountryIR' } }
      , { id : 'IQ' , name : { label : 'labelCountryIQ' } }
      , { id : 'IE' , name : { label : 'labelCountryIE' } }
      , { id : 'IM' , name : { label : 'labelCountryIM' } }
      , { id : 'IL' , name : { label : 'labelCountryIL' } }
      , { id : 'IT' , name : { label : 'labelCountryIT' } }
      , { id : 'JM' , name : { label : 'labelCountryJM' } }
      , { id : 'JP' , name : { label : 'labelCountryJP' } }
      , { id : 'JE' , name : { label : 'labelCountryJE' } }
      , { id : 'JO' , name : { label : 'labelCountryJO' } }
      , { id : 'KZ' , name : { label : 'labelCountryKZ' } }
      , { id : 'KE' , name : { label : 'labelCountryKE' } }
      , { id : 'KI' , name : { label : 'labelCountryKI' } }
      , { id : 'KP' , name : { label : 'labelCountryKP' } }
      , { id : 'KR' , name : { label : 'labelCountryKR' } }
      , { id : 'KW' , name : { label : 'labelCountryKW' } }
      , { id : 'KG' , name : { label : 'labelCountryKG' } }
      , { id : 'LA' , name : { label : 'labelCountryLA' } }
      , { id : 'LV' , name : { label : 'labelCountryLV' } }
      , { id : 'LB' , name : { label : 'labelCountryLB' } }
      , { id : 'LS' , name : { label : 'labelCountryLS' } }
      , { id : 'LR' , name : { label : 'labelCountryLR' } }
      , { id : 'LY' , name : { label : 'labelCountryLY' } }
      , { id : 'LI' , name : { label : 'labelCountryLI' } }
      , { id : 'LT' , name : { label : 'labelCountryLT' } }
      , { id : 'LU' , name : { label : 'labelCountryLU' } }
      , { id : 'MO' , name : { label : 'labelCountryMO' } }
      , { id : 'MK' , name : { label : 'labelCountryMK' } }
      , { id : 'MG' , name : { label : 'labelCountryMG' } }
      , { id : 'MW' , name : { label : 'labelCountryMW' } }
      , { id : 'MY' , name : { label : 'labelCountryMY' } }
      , { id : 'MV' , name : { label : 'labelCountryMV' } }
      , { id : 'ML' , name : { label : 'labelCountryML' } }
      , { id : 'MT' , name : { label : 'labelCountryMT' } }
      , { id : 'MH' , name : { label : 'labelCountryMH' } }
      , { id : 'MQ' , name : { label : 'labelCountryMQ' } }
      , { id : 'MR' , name : { label : 'labelCountryMR' } }
      , { id : 'MU' , name : { label : 'labelCountryMU' } }
      , { id : 'YT' , name : { label : 'labelCountryYT' } }
      , { id : 'MX' , name : { label : 'labelCountryMX' } }
      , { id : 'FM' , name : { label : 'labelCountryFM' } }
      , { id : 'MD' , name : { label : 'labelCountryMD' } }
      , { id : 'MC' , name : { label : 'labelCountryMC' } }
      , { id : 'MN' , name : { label : 'labelCountryMN' } }
      , { id : 'ME' , name : { label : 'labelCountryME' } }
      , { id : 'MS' , name : { label : 'labelCountryMS' } }
      , { id : 'MA' , name : { label : 'labelCountryMA' } }
      , { id : 'MZ' , name : { label : 'labelCountryMZ' } }
      , { id : 'MM' , name : { label : 'labelCountryMM' } }
      , { id : 'NA' , name : { label : 'labelCountryNA' } }
      , { id : 'NR' , name : { label : 'labelCountryNR' } }
      , { id : 'NP' , name : { label : 'labelCountryNP' } }
      , { id : 'NL' , name : { label : 'labelCountryNL' } }
      , { id : 'AN' , name : { label : 'labelCountryAN' } }
      , { id : 'NC' , name : { label : 'labelCountryNC' } }
      , { id : 'NZ' , name : { label : 'labelCountryNZ' } }
      , { id : 'NI' , name : { label : 'labelCountryNI' } }
      , { id : 'NE' , name : { label : 'labelCountryNE' } }
      , { id : 'NG' , name : { label : 'labelCountryNG' } }
      , { id : 'NU' , name : { label : 'labelCountryNU' } }
      , { id : 'NF' , name : { label : 'labelCountryNF' } }
      , { id : 'MP' , name : { label : 'labelCountryMP' } }
      , { id : 'NO' , name : { label : 'labelCountryNO' } }
      , { id : 'OM' , name : { label : 'labelCountryOM' } }
      , { id : 'PK' , name : { label : 'labelCountryPK' } }
      , { id : 'PW' , name : { label : 'labelCountryPW' } }
      , { id : 'PS' , name : { label : 'labelCountryPS' } }
      , { id : 'PA' , name : { label : 'labelCountryPA' } }
      , { id : 'PG' , name : { label : 'labelCountryPG' } }
      , { id : 'PY' , name : { label : 'labelCountryPY' } }
      , { id : 'PE' , name : { label : 'labelCountryPE' } }
      , { id : 'PH' , name : { label : 'labelCountryPH' } }
      , { id : 'PN' , name : { label : 'labelCountryPN' } }
      , { id : 'PL' , name : { label : 'labelCountryPL' } }
      , { id : 'PT' , name : { label : 'labelCountryPT' } }
      , { id : 'PR' , name : { label : 'labelCountryPR' } }
      , { id : 'QA' , name : { label : 'labelCountryQA' } }
      , { id : 'RE' , name : { label : 'labelCountryRE' } }
      , { id : 'RO' , name : { label : 'labelCountryRO' } }
      , { id : 'RU' , name : { label : 'labelCountryRU' } }
      , { id : 'RW' , name : { label : 'labelCountryRW' } }
      , { id : 'SH' , name : { label : 'labelCountrySH' } }
      , { id : 'KN' , name : { label : 'labelCountryKN' } }
      , { id : 'LC' , name : { label : 'labelCountryLC' } }
      , { id : 'PM' , name : { label : 'labelCountryPM' } }
      , { id : 'VC' , name : { label : 'labelCountryVC' } }
      , { id : 'WS' , name : { label : 'labelCountryWS' } }
      , { id : 'SM' , name : { label : 'labelCountrySM' } }
      , { id : 'ST' , name : { label : 'labelCountryST' } }
      , { id : 'SA' , name : { label : 'labelCountrySA' } }
      , { id : 'SN' , name : { label : 'labelCountrySN' } }
      , { id : 'RS' , name : { label : 'labelCountryRS' } }
      , { id : 'SC' , name : { label : 'labelCountrySC' } }
      , { id : 'SL' , name : { label : 'labelCountrySL' } }
      , { id : 'SG' , name : { label : 'labelCountrySG' } }
      , { id : 'SK' , name : { label : 'labelCountrySK' } }
      , { id : 'SI' , name : { label : 'labelCountrySI' } }
      , { id : 'SB' , name : { label : 'labelCountrySB' } }
      , { id : 'SO' , name : { label : 'labelCountrySO' } }
      , { id : 'ZA' , name : { label : 'labelCountryZA' } }
      , { id : 'GS' , name : { label : 'labelCountryGS' } }
      , { id : 'SS' , name : { label : 'labelCountrySS' } }
      , { id : 'ES' , name : { label : 'labelCountryES' } }
      , { id : 'LK' , name : { label : 'labelCountryLK' } }
      , { id : 'SD' , name : { label : 'labelCountrySD' } }
      , { id : 'SR' , name : { label : 'labelCountrySR' } }
      , { id : 'SJ' , name : { label : 'labelCountrySJ' } }
      , { id : 'SZ' , name : { label : 'labelCountrySZ' } }
      , { id : 'SE' , name : { label : 'labelCountrySE' } }
      , { id : 'CH' , name : { label : 'labelCountryCH' } }
      , { id : 'SY' , name : { label : 'labelCountrySY' } }
      , { id : 'TW' , name : { label : 'labelCountryTW' } }
      , { id : 'TJ' , name : { label : 'labelCountryTJ' } }
      , { id : 'TZ' , name : { label : 'labelCountryTZ' } }
      , { id : 'TH' , name : { label : 'labelCountryTH' } }
      , { id : 'TL' , name : { label : 'labelCountryTL' } }
      , { id : 'TG' , name : { label : 'labelCountryTG' } }
      , { id : 'TK' , name : { label : 'labelCountryTK' } }
      , { id : 'TO' , name : { label : 'labelCountryTO' } }
      , { id : 'TT' , name : { label : 'labelCountryTT' } }
      , { id : 'TN' , name : { label : 'labelCountryTN' } }
      , { id : 'TR' , name : { label : 'labelCountryTR' } }
      , { id : 'TM' , name : { label : 'labelCountryTM' } }
      , { id : 'TC' , name : { label : 'labelCountryTC' } }
      , { id : 'TV' , name : { label : 'labelCountryTV' } }
      , { id : 'UG' , name : { label : 'labelCountryUG' } }
      , { id : 'UA' , name : { label : 'labelCountryUA' } }
      , { id : 'AE' , name : { label : 'labelCountryAE' } }
      , { id : 'GB' , name : { label : 'labelCountryGB' } }
      , { id : 'US' , name : { label : 'labelCountryUS' } }
      , { id : 'UM' , name : { label : 'labelCountryUM' } }
      , { id : 'UY' , name : { label : 'labelCountryUY' } }
      , { id : 'UZ' , name : { label : 'labelCountryUZ' } }
      , { id : 'VU' , name : { label : 'labelCountryVU' } }
      , { id : 'VE' , name : { label : 'labelCountryVE' } }
      , { id : 'VN' , name : { label : 'labelCountryVN' } }
      , { id : 'VG' , name : { label : 'labelCountryVG' } }
      , { id : 'VI' , name : { label : 'labelCountryVI' } }
      , { id : 'WF' , name : { label : 'labelCountryWF' } }
      , { id : 'EH' , name : { label : 'labelCountryEH' } }
      , { id : 'YE' , name : { label : 'labelCountryYE' } }
      , { id : 'ZM' , name : { label : 'labelCountryZM' } }
      , { id : 'ZW' , name : { label : 'labelCountryZW' } }
    ];
    
    /**
     * The data, as a map (by ID).
     * @private
     * @type {Object.<string,Object>}
     */
    tsa.data.Countries._dataMap = {};
    
    $.each( tsa.data.Countries._data, function( index, country )
    {
      tsa.data.Countries._dataMap[ country.id ] = country;
    } );
    
    /**
     * Access method: get country by ID.
     * @param {string} id The country ID.
     * @return {Object}   The country data, or null if ID is not found.
     */
    tsa.data.Countries.getById = function( id )
    {
      /** @type {Object} */var country = null;
      
      if( TV.typeIsString( typeof id ) )
      {
        if( TV.typeIsObject( typeof tsa.data.Countries._dataMap[ id ] ) )
        {
          country = tsa.data.Countries._dataMap[ id ];
        }
      }
      
      return country;
    };
    
    /**
     * Access method: get countries, sorted by name.
     * @param {string=}         lang The language ID (currently only English is supported: 'en').
     *                               Optional. Default: 'en' (English).
     * @return {Array.<Object>}      The countries data.
     */
    tsa.data.Countries.getCountries = function( lang )
    {
      /** @type {Array.<Object>} */ var result = null;
      
      if( !TV.typeIsString( typeof lang ) )
      {
        lang = 'en';
      }
      
      result = tsa.data.Countries._data.slice();
      
      result.sort( function( countryA, countryB )
      {
        /** @type {number} */ var result = 0;
        
        try
        {
          result = countryA.name[ lang ].localeCompare( countryB.name[ lang ] );
        }
        catch( error ) { /* ignore */ }
        
        return result;
      } );
      
      return result;
    };
    
    return tsa.data.Countries;
  }
);